<?php
/**
 * Created by PhpStorm.
 * User: user
 * Date: 6/27/14
 * Time: 10:10 AM
 */

class ControllerPaymentBpay extends Controller {

    private $error = array();

    public function index() {
        $this->language->load('payment/bpay');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('bpay', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->redirect($this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'));
        }

        $this->data['heading_title'] = $this->language->get('heading_title');

        $this->data['text_enabled'] = $this->language->get('text_enabled');
        $this->data['text_disabled'] = $this->language->get('text_disabled');
        $this->data['text_all_zones'] = $this->language->get('text_all_zones');
        $this->data['text_yes'] = $this->language->get('text_yes');
        $this->data['text_no'] = $this->language->get('text_no');
        $this->data['text_authorization'] = $this->language->get('text_authorization');
        $this->data['text_sale'] = $this->language->get('text_sale');

        $this->data['entry_merchantid'] = $this->language->get('entry_merchantid');
        $this->data['entry_istest'] = $this->language->get('entry_istest');
        $this->data['entry_method'] = $this->language->get('entry_method');
        $this->data['entry_success_url'] = $this->language->get('entry_success_url');
        $this->data['entry_fail_url'] = $this->language->get('entry_fail_url');
        $this->data['entry_callback_url'] = $this->language->get('entry_callback_url');
        $this->data['entry_signature'] = $this->language->get('entry_signature');
        $this->data['entry_status'] = $this->language->get('entry_status');
        $this->data['entry_sort_order'] = $this->language->get('entry_sort_order');

        $this->data['button_save'] = $this->language->get('button_save');
        $this->data['button_cancel'] = $this->language->get('button_cancel');

        if (isset($this->error['warning'])) {
            $this->data['error_warning'] = $this->error['warning'];
        } else {
            $this->data['error_warning'] = '';
        }

        if (isset($this->error['merchant'])) {
            $this->data['error_merchant'] = $this->error['merchant'];
        } else {
            $this->data['error_merchant'] = '';
        }

        if (isset($this->error['signature'])) {
            $this->data['error_signature'] = $this->error['signature'];
        } else {
            $this->data['error_signature'] = '';
        }


        $this->data['breadcrumbs'] = array();

        $this->data['breadcrumbs'][] = array(
            'text'      => $this->language->get('text_home'),
            'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => false
        );

        $this->data['breadcrumbs'][] = array(
            'text'      => $this->language->get('text_payment'),
            'href'      => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['breadcrumbs'][] = array(
            'text'      => $this->language->get('heading_title'),
            'href'      => $this->url->link('payment/pp_standard', 'token=' . $this->session->data['token'], 'SSL'),
            'separator' => ' :: '
        );

        $this->data['action'] = $this->url->link('payment/bpay', 'token=' . $this->session->data['token'], 'SSL');

        $this->data['cancel'] = $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL');


        if (isset($this->request->post['bpay_merchantid'])) {
            $this->data['bpay_merchantid'] = $this->request->post['bpay_merchantid'];
        } else {
            $this->data['bpay_merchantid'] = $this->config->get('bpay_merchantid');
        }

        if (isset($this->request->post['bpay_signature'])) {
            $this->data['bpay_signature'] = $this->request->post['bpay_signature'];
        } else {
            $this->data['bpay_signature'] = $this->config->get('bpay_signature');
        }

        if (isset($this->request->post['bpay_istest'])) {
            $this->data['bpay_istest'] = $this->request->post['bpay_istest'];
        } else {
            $this->data['bpay_istest'] = $this->config->get('bpay_istest');
        }

        if (isset($this->request->post['bpay_method'])) {
            $this->data['bpay_method'] = $this->request->post['bpay_method'];
        } else {
            $this->data['bpay_method'] = $this->config->get('bpay_method');
        }

        if (isset($this->request->post['bpay_success_url'])) {
            $this->data['bpay_success_url'] = $this->request->post['bpay_success_url'];
        } else {
            $this->data['bpay_success_url'] = $this->config->get('bpay_success_url');
        }

        if (isset($this->request->post['bpay_fail_url'])) {
            $this->data['bpay_fail_url'] = $this->request->post['bpay_fail_url'];
        } else {
            $this->data['bpay_fail_url'] = $this->config->get('bpay_fail_url');
        }

        if (isset($this->request->post['bpay_callback_url'])) {
            $this->data['bpay_callback_url'] = $this->request->post['bpay_callback_url'];
        } else {
            $this->data['bpay_callback_url'] = $this->config->get('bpay_callback_url');
        }

        if (isset($this->request->post['bpay_status'])) {
            $this->data['bpay_status'] = $this->request->post['bpay_status'];
        } else {
            $this->data['bpay_status'] = $this->config->get('bpay_status');
        }

        if (isset($this->request->post['bpay_sort_order'])) {
            $this->data['bpay_sort_order'] = $this->request->post['bpay_sort_order'];
        } else {
            $this->data['bpay_sort_order'] = $this->config->get('bpay_sort_order');
        }

        $this->template = 'payment/bpay.tpl';
        $this->children = array(
            'common/header',
            'common/footer'
        );

        $this->response->setOutput($this->render());
    }

    protected function validate() {
        if (!$this->user->hasPermission('modify', 'payment/pp_standard')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->request->post['bpay_merchantid']) {
            $this->error['merchant'] = $this->language->get('error_merchant');
        }

        if (!$this->request->post['bpay_signature']) {
            $this->error['signature'] = $this->language->get('error_signature');
        }

        if (!$this->error) {
            return true;
        } else {
            return false;
        }
    }

} 